{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.Globalization.UnicodeCategory where

import NET
import qualified System.IO.Unsafe
import qualified NET.System.Type
import qualified NET.System.Enum

type UnicodeCategory a = Int

data UnicodeCategoryTy
 = UppercaseLetter
 | LowercaseLetter
 | TitlecaseLetter
 | ModifierLetter
 | OtherLetter
 | NonSpacingMark
 | SpacingCombiningMark
 | EnclosingMark
 | DecimalDigitNumber
 | LetterNumber
 | OtherNumber
 | SpaceSeparator
 | LineSeparator
 | ParagraphSeparator
 | Control
 | Format
 | Surrogate
 | PrivateUse
 | ConnectorPunctuation
 | DashPunctuation
 | OpenPunctuation
 | ClosePunctuation
 | InitialQuotePunctuation
 | FinalQuotePunctuation
 | OtherPunctuation
 | MathSymbol
 | CurrencySymbol
 | ModifierSymbol
 | OtherSymbol
 | OtherNotAssigned
  deriving ( Enum, Show, Read )
toUnicodeCategory :: UnicodeCategoryTy -> UnicodeCategory ()
toUnicodeCategory tag = fromEnum tag

fromUnicodeCategory :: UnicodeCategory () -> UnicodeCategoryTy
fromUnicodeCategory obj = toEnum obj

