{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.IO.BinaryReader ( module NET.System.IO.BinaryReader ) where

import NET
import NET.System.IO.BinaryReader.Type as System.IO.BinaryReader
import qualified NET.System.IO.Stream
import qualified Data.Word
import qualified Data.Int
import qualified NET.System.Decimal
import qualified NET.System.Array
import qualified NET.System.Object

get_BaseStream :: BinaryReader obj -> IO (NET.System.IO.Stream.Stream a0)
get_BaseStream = invoke "get_BaseStream" () 

close :: BinaryReader obj -> IO (())
close = invoke "Close" () 

peekChar :: BinaryReader obj -> IO (Int)
peekChar = invoke "PeekChar" () 

read :: BinaryReader obj -> IO (Int)
read = invoke "Read" () 

readBoolean :: BinaryReader obj -> IO (Bool)
readBoolean = invoke "ReadBoolean" () 

readByte :: BinaryReader obj -> IO (Data.Word.Word8)
readByte = invoke "ReadByte" () 

readSByte :: BinaryReader obj -> IO (Data.Int.Int8)
readSByte = invoke "ReadSByte" () 

readChar :: BinaryReader obj -> IO (Char)
readChar = invoke "ReadChar" () 

readInt16 :: BinaryReader obj -> IO (Data.Int.Int16)
readInt16 = invoke "ReadInt16" () 

readUInt16 :: BinaryReader obj -> IO (Data.Word.Word16)
readUInt16 = invoke "ReadUInt16" () 

readInt32 :: BinaryReader obj -> IO (Int)
readInt32 = invoke "ReadInt32" () 

readUInt32 :: BinaryReader obj -> IO (Data.Word.Word32)
readUInt32 = invoke "ReadUInt32" () 

readInt64 :: BinaryReader obj -> IO (Data.Int.Int64)
readInt64 = invoke "ReadInt64" () 

readUInt64 :: BinaryReader obj -> IO (Data.Word.Word64)
readUInt64 = invoke "ReadUInt64" () 

readSingle :: BinaryReader obj -> IO (Double)
readSingle = invoke "ReadSingle" () 

readDouble :: BinaryReader obj -> IO (Double)
readDouble = invoke "ReadDouble" () 

readDecimal :: BinaryReader obj -> IO (NET.System.Decimal.Decimal a0)
readDecimal = invoke "ReadDecimal" () 

readString :: BinaryReader obj -> IO (String)
readString = invoke "ReadString" () 

read_1 :: NET.System.Array.Array (Char) -> Int -> Int -> BinaryReader obj -> IO (Int)
read_1 arg0 arg1 arg2 = invoke "Read" (arg0, arg1, arg2)

readChars :: Int -> BinaryReader obj -> IO (NET.System.Array.Array (Char))
readChars arg0 = invoke "ReadChars" (arg0)

read_2 :: NET.System.Array.Array (Data.Word.Word8) -> Int -> Int -> BinaryReader obj -> IO (Int)
read_2 arg0 arg1 arg2 = invoke "Read" (arg0, arg1, arg2)

readBytes :: Int -> BinaryReader obj -> IO (NET.System.Array.Array (Data.Word.Word8))
readBytes arg0 = invoke "ReadBytes" (arg0)


