{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.IO.TextWriter where

import NET
import qualified NET.System.IFormatProvider
import qualified NET.System.Text.Encoding
import qualified NET.System.Array
import qualified Data.Word
import qualified Data.Int
import qualified NET.System.Decimal
import qualified NET.System.Object
import qualified NET.System.MarshalByRefObject

data TextWriter_ a
type TextWriter a = NET.System.MarshalByRefObject.MarshalByRefObject (TextWriter_ a)

get_FormatProvider :: NET.System.IFormatProvider.IFormatProvider a0 => TextWriter obj -> IO (NET.Object a0)
get_FormatProvider = invoke "get_FormatProvider" () 

close :: TextWriter obj -> IO (())
close = invoke "Close" () 

dispose :: TextWriter obj -> IO (())
dispose = invoke "Dispose" () 

flush :: TextWriter obj -> IO (())
flush = invoke "Flush" () 

get_Encoding :: TextWriter obj -> IO (NET.System.Text.Encoding.Encoding a0)
get_Encoding = invoke "get_Encoding" () 

get_NewLine :: TextWriter obj -> IO (String)
get_NewLine = invoke "get_NewLine" () 

set_NewLine :: String -> TextWriter obj -> IO (())
set_NewLine arg0 = invoke "set_NewLine" (arg0)

synchronized :: NET.System.IO.TextWriter.TextWriter a0 -> IO (NET.System.IO.TextWriter.TextWriter a1)
synchronized arg0 = invokeStatic "System.IO.TextWriter" "Synchronized" (arg0)

write :: Char -> TextWriter obj -> IO (())
write arg0 = invoke "Write" (arg0)

write_1 :: NET.System.Array.Array (Char) -> TextWriter obj -> IO (())
write_1 arg0 = invoke "Write" (arg0)

write_2 :: NET.System.Array.Array (Char) -> Int -> Int -> TextWriter obj -> IO (())
write_2 arg0 arg1 arg2 = invoke "Write" (arg0, arg1, arg2)

write_3 :: Bool -> TextWriter obj -> IO (())
write_3 arg0 = invoke "Write" (arg0)

write_4 :: Int -> TextWriter obj -> IO (())
write_4 arg0 = invoke "Write" (arg0)

write_5 :: Data.Word.Word32 -> TextWriter obj -> IO (())
write_5 arg0 = invoke "Write" (arg0)

write_6 :: Data.Int.Int64 -> TextWriter obj -> IO (())
write_6 arg0 = invoke "Write" (arg0)

write_7 :: Data.Word.Word64 -> TextWriter obj -> IO (())
write_7 arg0 = invoke "Write" (arg0)

write_8 :: Double -> TextWriter obj -> IO (())
write_8 arg0 = invoke "Write" (arg0)

write_9 :: Double -> TextWriter obj -> IO (())
write_9 arg0 = invoke "Write" (arg0)

write_10 :: NET.System.Decimal.Decimal a0 -> TextWriter obj -> IO (())
write_10 arg0 = invoke "Write" (arg0)

write_11 :: String -> TextWriter obj -> IO (())
write_11 arg0 = invoke "Write" (arg0)

write_12 :: NET.System.Object.Object a0 -> TextWriter obj -> IO (())
write_12 arg0 = invoke "Write" (arg0)

write_13 :: String -> NET.System.Object.Object a1 -> TextWriter obj -> IO (())
write_13 arg0 arg1 = invoke "Write" (arg0, arg1)

write_14 :: String -> NET.System.Object.Object a1 -> NET.System.Object.Object a2 -> TextWriter obj -> IO (())
write_14 arg0 arg1 arg2 = invoke "Write" (arg0, arg1, arg2)

write_15 :: String -> NET.System.Object.Object a1 -> NET.System.Object.Object a2 -> NET.System.Object.Object a3 -> TextWriter obj -> IO (())
write_15 arg0 arg1 arg2 arg3 = invoke "Write" (arg0, arg1, arg2, arg3)

write_16 :: String -> NET.System.Array.Array (NET.System.Object.Object a1) -> TextWriter obj -> IO (())
write_16 arg0 arg1 = invoke "Write" (arg0, arg1)

writeLine :: TextWriter obj -> IO (())
writeLine = invoke "WriteLine" () 

writeLine_1 :: Char -> TextWriter obj -> IO (())
writeLine_1 arg0 = invoke "WriteLine" (arg0)

writeLine_2 :: NET.System.Array.Array (Char) -> TextWriter obj -> IO (())
writeLine_2 arg0 = invoke "WriteLine" (arg0)

writeLine_3 :: NET.System.Array.Array (Char) -> Int -> Int -> TextWriter obj -> IO (())
writeLine_3 arg0 arg1 arg2 = invoke "WriteLine" (arg0, arg1, arg2)

writeLine_4 :: Bool -> TextWriter obj -> IO (())
writeLine_4 arg0 = invoke "WriteLine" (arg0)

writeLine_5 :: Int -> TextWriter obj -> IO (())
writeLine_5 arg0 = invoke "WriteLine" (arg0)

writeLine_6 :: Data.Word.Word32 -> TextWriter obj -> IO (())
writeLine_6 arg0 = invoke "WriteLine" (arg0)

writeLine_7 :: Data.Int.Int64 -> TextWriter obj -> IO (())
writeLine_7 arg0 = invoke "WriteLine" (arg0)

writeLine_8 :: Data.Word.Word64 -> TextWriter obj -> IO (())
writeLine_8 arg0 = invoke "WriteLine" (arg0)

writeLine_9 :: Double -> TextWriter obj -> IO (())
writeLine_9 arg0 = invoke "WriteLine" (arg0)

writeLine_10 :: Double -> TextWriter obj -> IO (())
writeLine_10 arg0 = invoke "WriteLine" (arg0)

writeLine_11 :: NET.System.Decimal.Decimal a0 -> TextWriter obj -> IO (())
writeLine_11 arg0 = invoke "WriteLine" (arg0)

writeLine_12 :: String -> TextWriter obj -> IO (())
writeLine_12 arg0 = invoke "WriteLine" (arg0)

writeLine_13 :: NET.System.Object.Object a0 -> TextWriter obj -> IO (())
writeLine_13 arg0 = invoke "WriteLine" (arg0)

writeLine_14 :: String -> NET.System.Object.Object a1 -> TextWriter obj -> IO (())
writeLine_14 arg0 arg1 = invoke "WriteLine" (arg0, arg1)

writeLine_15 :: String -> NET.System.Object.Object a1 -> NET.System.Object.Object a2 -> TextWriter obj -> IO (())
writeLine_15 arg0 arg1 arg2 = invoke "WriteLine" (arg0, arg1, arg2)

writeLine_16 :: String -> NET.System.Object.Object a1 -> NET.System.Object.Object a2 -> NET.System.Object.Object a3 -> TextWriter obj -> IO (())
writeLine_16 arg0 arg1 arg2 arg3 = invoke "WriteLine" (arg0, arg1, arg2, arg3)

writeLine_17 :: String -> NET.System.Array.Array (NET.System.Object.Object a1) -> TextWriter obj -> IO (())
writeLine_17 arg0 arg1 = invoke "WriteLine" (arg0, arg1)

get_Null :: IO (NET.System.IO.TextWriter.TextWriter a0)
get_Null = getFieldStatic "System.IO.TextWriter" "Null" ()

