{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.Runtime.Serialization.SerializationInfo ( module NET.System.Runtime.Serialization.SerializationInfo ) where

import NET
import NET.System.Runtime.Serialization.SerializationInfo.Type as NET.System.Runtime.Serialization.SerializationInfo
import qualified NET.System.Type
import qualified Data.Int
import qualified NET.System.Runtime.Serialization.SerializationInfoEnumerator
import qualified NET.System.Object
import qualified Data.Word
import qualified NET.System.Decimal
import qualified NET.System.DateTime

get_FullTypeName :: SerializationInfo obj -> IO (String)
get_FullTypeName = invoke "get_FullTypeName" () 

set_FullTypeName :: String -> SerializationInfo obj -> IO (())
set_FullTypeName arg0 = invoke "set_FullTypeName" (arg0)

get_AssemblyName :: SerializationInfo obj -> IO (String)
get_AssemblyName = invoke "get_AssemblyName" () 

set_AssemblyName :: String -> SerializationInfo obj -> IO (())
set_AssemblyName arg0 = invoke "set_AssemblyName" (arg0)

setType :: NET.System.Type.Type a0 -> SerializationInfo obj -> IO (())
setType arg0 = invoke "SetType" (arg0)

get_MemberCount :: SerializationInfo obj -> IO (Data.Int.Int32)
get_MemberCount = invoke "get_MemberCount" () 

getEnumerator :: SerializationInfo obj -> IO (NET.System.Runtime.Serialization.SerializationInfoEnumerator.SerializationInfoEnumerator a0)
getEnumerator = invoke "GetEnumerator" () 

addValue :: String -> NET.System.Object.Object a1 -> NET.System.Type.Type a2 -> SerializationInfo obj -> IO (())
addValue arg0 arg1 arg2 = invoke "AddValue" (arg0, arg1, arg2)

addValue_1 :: String -> NET.System.Object.Object a1 -> SerializationInfo obj -> IO (())
addValue_1 arg0 arg1 = invoke "AddValue" (arg0, arg1)

addValue_2 :: String -> Bool -> SerializationInfo obj -> IO (())
addValue_2 arg0 arg1 = invoke "AddValue" (arg0, arg1)

addValue_3 :: String -> Char -> SerializationInfo obj -> IO (())
addValue_3 arg0 arg1 = invoke "AddValue" (arg0, arg1)

addValue_4 :: String -> Data.Int.Int8 -> SerializationInfo obj -> IO (())
addValue_4 arg0 arg1 = invoke "AddValue" (arg0, arg1)

addValue_5 :: String -> Data.Word.Word8 -> SerializationInfo obj -> IO (())
addValue_5 arg0 arg1 = invoke "AddValue" (arg0, arg1)

addValue_6 :: String -> Data.Int.Int16 -> SerializationInfo obj -> IO (())
addValue_6 arg0 arg1 = invoke "AddValue" (arg0, arg1)

addValue_7 :: String -> Data.Word.Word16 -> SerializationInfo obj -> IO (())
addValue_7 arg0 arg1 = invoke "AddValue" (arg0, arg1)

addValue_8 :: String -> Data.Int.Int32 -> SerializationInfo obj -> IO (())
addValue_8 arg0 arg1 = invoke "AddValue" (arg0, arg1)

addValue_9 :: String -> Data.Word.Word32 -> SerializationInfo obj -> IO (())
addValue_9 arg0 arg1 = invoke "AddValue" (arg0, arg1)

addValue_10 :: String -> Data.Int.Int64 -> SerializationInfo obj -> IO (())
addValue_10 arg0 arg1 = invoke "AddValue" (arg0, arg1)

addValue_11 :: String -> Data.Word.Word64 -> SerializationInfo obj -> IO (())
addValue_11 arg0 arg1 = invoke "AddValue" (arg0, arg1)

addValue_12 :: String -> Float -> SerializationInfo obj -> IO (())
addValue_12 arg0 arg1 = invoke "AddValue" (arg0, arg1)

addValue_13 :: String -> Double -> SerializationInfo obj -> IO (())
addValue_13 arg0 arg1 = invoke "AddValue" (arg0, arg1)

addValue_14 :: String -> NET.System.Decimal.Decimal a1 -> SerializationInfo obj -> IO (())
addValue_14 arg0 arg1 = invoke "AddValue" (arg0, arg1)

addValue_15 :: String -> NET.System.DateTime.DateTime a1 -> SerializationInfo obj -> IO (())
addValue_15 arg0 arg1 = invoke "AddValue" (arg0, arg1)

getValue :: String -> NET.System.Type.Type a1 -> SerializationInfo obj -> IO (NET.System.Object.Object a2)
getValue arg0 arg1 = invoke "GetValue" (arg0, arg1)

getBoolean :: String -> SerializationInfo obj -> IO (Bool)
getBoolean arg0 = invoke "GetBoolean" (arg0)

getChar :: String -> SerializationInfo obj -> IO (Char)
getChar arg0 = invoke "GetChar" (arg0)

getSByte :: String -> SerializationInfo obj -> IO (Data.Int.Int8)
getSByte arg0 = invoke "GetSByte" (arg0)

getByte :: String -> SerializationInfo obj -> IO (Data.Word.Word8)
getByte arg0 = invoke "GetByte" (arg0)

getInt16 :: String -> SerializationInfo obj -> IO (Data.Int.Int16)
getInt16 arg0 = invoke "GetInt16" (arg0)

getUInt16 :: String -> SerializationInfo obj -> IO (Data.Word.Word16)
getUInt16 arg0 = invoke "GetUInt16" (arg0)

getInt32 :: String -> SerializationInfo obj -> IO (Data.Int.Int32)
getInt32 arg0 = invoke "GetInt32" (arg0)

getUInt32 :: String -> SerializationInfo obj -> IO (Data.Word.Word32)
getUInt32 arg0 = invoke "GetUInt32" (arg0)

getInt64 :: String -> SerializationInfo obj -> IO (Data.Int.Int64)
getInt64 arg0 = invoke "GetInt64" (arg0)

getUInt64 :: String -> SerializationInfo obj -> IO (Data.Word.Word64)
getUInt64 arg0 = invoke "GetUInt64" (arg0)

getSingle :: String -> SerializationInfo obj -> IO (Float)
getSingle arg0 = invoke "GetSingle" (arg0)

getDouble :: String -> SerializationInfo obj -> IO (Double)
getDouble arg0 = invoke "GetDouble" (arg0)

getDecimal :: String -> SerializationInfo obj -> IO (NET.System.Decimal.Decimal a1)
getDecimal arg0 = invoke "GetDecimal" (arg0)

getDateTime :: String -> SerializationInfo obj -> IO (NET.System.DateTime.DateTime a1)
getDateTime arg0 = invoke "GetDateTime" (arg0)

getString :: String -> SerializationInfo obj -> IO (String)
getString arg0 = invoke "GetString" (arg0)


