{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.Uri ( module NET.System.Uri ) where

import qualified NET
import NET.System.Uri.Type as NET.System.Uri
import qualified NET.System.UriHostNameType.Type as NET.System.UriHostNameType
import qualified Data.Int
import qualified NET.System.Array
import qualified NET.System.UriPartial.Type as NET.System.UriPartial
import qualified NET.System.UriKind.Type as NET.System.UriKind
import qualified NET.System.UriComponents.Type as NET.System.UriComponents
import qualified NET.System.UriFormat.Type as NET.System.UriFormat
import qualified NET.System.StringComparison.Type as NET.System.StringComparison
import qualified NET.System.Object

get_AbsolutePath :: Uri obj -> IO (String)
get_AbsolutePath obj = NET.invoke "get_AbsolutePath"  ()  obj

get_AbsoluteUri :: Uri obj -> IO (String)
get_AbsoluteUri obj = NET.invoke "get_AbsoluteUri"  ()  obj

get_Authority :: Uri obj -> IO (String)
get_Authority obj = NET.invoke "get_Authority"  ()  obj

get_Host :: Uri obj -> IO (String)
get_Host obj = NET.invoke "get_Host"  ()  obj

get_HostNameType :: Uri obj -> IO (NET.System.UriHostNameType.UriHostNameType a0)
get_HostNameType obj = NET.invoke "get_HostNameType"  ()  obj

get_IsDefaultPort :: Uri obj -> IO (Bool)
get_IsDefaultPort obj = NET.invoke "get_IsDefaultPort"  ()  obj

get_IsFile :: Uri obj -> IO (Bool)
get_IsFile obj = NET.invoke "get_IsFile"  ()  obj

get_IsLoopback :: Uri obj -> IO (Bool)
get_IsLoopback obj = NET.invoke "get_IsLoopback"  ()  obj

get_IsUnc :: Uri obj -> IO (Bool)
get_IsUnc obj = NET.invoke "get_IsUnc"  ()  obj

get_LocalPath :: Uri obj -> IO (String)
get_LocalPath obj = NET.invoke "get_LocalPath"  ()  obj

get_PathAndQuery :: Uri obj -> IO (String)
get_PathAndQuery obj = NET.invoke "get_PathAndQuery"  ()  obj

get_Port :: Uri obj -> IO (Data.Int.Int32)
get_Port obj = NET.invoke "get_Port"  ()  obj

get_Query :: Uri obj -> IO (String)
get_Query obj = NET.invoke "get_Query"  ()  obj

get_Fragment :: Uri obj -> IO (String)
get_Fragment obj = NET.invoke "get_Fragment"  ()  obj

get_Scheme :: Uri obj -> IO (String)
get_Scheme obj = NET.invoke "get_Scheme"  ()  obj

get_OriginalString :: Uri obj -> IO (String)
get_OriginalString obj = NET.invoke "get_OriginalString"  ()  obj

get_DnsSafeHost :: Uri obj -> IO (String)
get_DnsSafeHost obj = NET.invoke "get_DnsSafeHost"  ()  obj

get_IsAbsoluteUri :: Uri obj -> IO (Bool)
get_IsAbsoluteUri obj = NET.invoke "get_IsAbsoluteUri"  ()  obj

get_Segments :: Uri obj -> IO (NET.System.Array.Array (String))
get_Segments obj = NET.invoke "get_Segments"  ()  obj

get_UserEscaped :: Uri obj -> IO (Bool)
get_UserEscaped obj = NET.invoke "get_UserEscaped"  ()  obj

get_UserInfo :: Uri obj -> IO (String)
get_UserInfo obj = NET.invoke "get_UserInfo"  ()  obj

checkHostName :: String -> IO (NET.System.UriHostNameType.UriHostNameType a1)
checkHostName arg0 = NET.invokeStatic "System.Uri" "CheckHostName"  (arg0)

checkSchemeName :: String -> IO (Bool)
checkSchemeName arg0 = NET.invokeStatic "System.Uri" "CheckSchemeName"  (arg0)

fromHex :: Char -> IO (Data.Int.Int32)
fromHex arg0 = NET.invokeStatic "System.Uri" "FromHex"  (arg0)

getHashCode :: Uri obj -> IO (Data.Int.Int32)
getHashCode obj = NET.invoke "GetHashCode"  ()  obj

toString :: Uri obj -> IO (String)
toString obj = NET.invoke "ToString"  ()  obj

op_Equality :: NET.System.Uri.Uri a0 -> NET.System.Uri.Uri a1 -> IO (Bool)
op_Equality arg0 arg1 = NET.invokeStatic "System.Uri" "op_Equality"  (arg0, arg1)

op_Inequality :: NET.System.Uri.Uri a0 -> NET.System.Uri.Uri a1 -> IO (Bool)
op_Inequality arg0 arg1 = NET.invokeStatic "System.Uri" "op_Inequality"  (arg0, arg1)

equals :: NET.Object (objTy0 a0) -> Uri obj -> IO (Bool)
equals arg0 obj = NET.invoke "Equals"  (arg0) obj

getLeftPart :: NET.System.UriPartial.UriPartial a0 -> Uri obj -> IO (String)
getLeftPart arg0 obj = NET.invoke "GetLeftPart"  (arg0) obj

hexEscape :: Char -> IO (String)
hexEscape arg0 = NET.invokeStatic "System.Uri" "HexEscape"  (arg0)

hexUnescape :: String -> Data.Int.Int32 -> IO (Char)
hexUnescape arg0 arg1 = NET.invokeStatic "System.Uri" "HexUnescape"  (arg0, arg1)

isHexDigit :: Char -> IO (Bool)
isHexDigit arg0 = NET.invokeStatic "System.Uri" "IsHexDigit"  (arg0)

isHexEncoding :: String -> Data.Int.Int32 -> IO (Bool)
isHexEncoding arg0 arg1 = NET.invokeStatic "System.Uri" "IsHexEncoding"  (arg0, arg1)

makeRelative :: NET.System.Uri.Uri a0 -> Uri obj -> IO (String)
makeRelative arg0 obj = NET.invoke "MakeRelative"  (arg0) obj

makeRelativeUri :: NET.System.Uri.Uri a0 -> Uri obj -> IO (NET.System.Uri.Uri a1)
makeRelativeUri arg0 obj = NET.invoke "MakeRelativeUri"  (arg0) obj

tryCreate :: String -> NET.System.UriKind.UriKind a1 -> NET.System.Uri.Uri a2 -> IO (Bool)
tryCreate arg0 arg1 arg2 = NET.invokeStatic "System.Uri" "TryCreate"  (arg0, arg1, arg2)

tryCreate_1 :: NET.System.Uri.Uri a0 -> String -> NET.System.Uri.Uri a2 -> IO (Bool)
tryCreate_1 arg0 arg1 arg2 = NET.invokeStatic "System.Uri" "TryCreate"  (arg0, arg1, arg2)

tryCreate_2 :: NET.System.Uri.Uri a0 -> NET.System.Uri.Uri a1 -> NET.System.Uri.Uri a2 -> IO (Bool)
tryCreate_2 arg0 arg1 arg2 = NET.invokeStatic "System.Uri" "TryCreate"  (arg0, arg1, arg2)

isBaseOf :: NET.System.Uri.Uri a0 -> Uri obj -> IO (Bool)
isBaseOf arg0 obj = NET.invoke "IsBaseOf"  (arg0) obj

getComponents :: NET.System.UriComponents.UriComponents a0 -> NET.System.UriFormat.UriFormat a1 -> Uri obj -> IO (String)
getComponents arg0 arg1 obj = NET.invoke "GetComponents"  (arg0, arg1) obj

isWellFormedOriginalString :: Uri obj -> IO (Bool)
isWellFormedOriginalString obj = NET.invoke "IsWellFormedOriginalString"  ()  obj

isWellFormedUriString :: String -> NET.System.UriKind.UriKind a1 -> IO (Bool)
isWellFormedUriString arg0 arg1 = NET.invokeStatic "System.Uri" "IsWellFormedUriString"  (arg0, arg1)

compare :: NET.System.Uri.Uri a0 -> NET.System.Uri.Uri a1 -> NET.System.UriComponents.UriComponents a2 -> NET.System.UriFormat.UriFormat a3 -> NET.System.StringComparison.StringComparison a4 -> IO (Data.Int.Int32)
compare arg0 arg1 arg2 arg3 arg4 = NET.invokeStatic "System.Uri" "Compare"  (arg0, arg1, arg2, arg3, arg4)

unescapeDataString :: String -> IO (String)
unescapeDataString arg0 = NET.invokeStatic "System.Uri" "UnescapeDataString"  (arg0)

escapeUriString :: String -> IO (String)
escapeUriString arg0 = NET.invokeStatic "System.Uri" "EscapeUriString"  (arg0)

escapeDataString :: String -> IO (String)
escapeDataString arg0 = NET.invokeStatic "System.Uri" "EscapeDataString"  (arg0)

get_UriSchemeFile :: IO (String)
get_UriSchemeFile = NET.getFieldStatic "System.Uri" "UriSchemeFile" ()
get_UriSchemeFtp :: IO (String)
get_UriSchemeFtp = NET.getFieldStatic "System.Uri" "UriSchemeFtp" ()
get_UriSchemeGopher :: IO (String)
get_UriSchemeGopher = NET.getFieldStatic "System.Uri" "UriSchemeGopher" ()
get_UriSchemeHttp :: IO (String)
get_UriSchemeHttp = NET.getFieldStatic "System.Uri" "UriSchemeHttp" ()
get_UriSchemeHttps :: IO (String)
get_UriSchemeHttps = NET.getFieldStatic "System.Uri" "UriSchemeHttps" ()
get_UriSchemeMailto :: IO (String)
get_UriSchemeMailto = NET.getFieldStatic "System.Uri" "UriSchemeMailto" ()
get_UriSchemeNews :: IO (String)
get_UriSchemeNews = NET.getFieldStatic "System.Uri" "UriSchemeNews" ()
get_UriSchemeNntp :: IO (String)
get_UriSchemeNntp = NET.getFieldStatic "System.Uri" "UriSchemeNntp" ()
get_UriSchemeNetTcp :: IO (String)
get_UriSchemeNetTcp = NET.getFieldStatic "System.Uri" "UriSchemeNetTcp" ()
get_UriSchemeNetPipe :: IO (String)
get_UriSchemeNetPipe = NET.getFieldStatic "System.Uri" "UriSchemeNetPipe" ()
get_SchemeDelimiter :: IO (String)
get_SchemeDelimiter = NET.getFieldStatic "System.Uri" "SchemeDelimiter" ()

